#ifndef  __NETUTL__
#define  __NETUTL__

#include <string>
using namespace std;

extern "C"{
#include <netdb.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
}

const string Myname(string &myip){
  char name[80];
  gethostname(name,80);
  string myname = name;

  struct hostent* ent= gethostbyname(name);
  struct in_addr adr = {*(unsigned long *)ent->h_addr_list[0]};
  myip = inet_ntoa(adr);
  return myname;

}

int Listener(Socket* sock, int port, const string this_ip="0.0.0.0");

// Binding and Listening
inline int Listener(Socket* sock, int port, const string this_ip){
  int status;
  string myip;
  if(this_ip =="0.0.0.0" || this_ip.length()==0){
    string myname = Myname(myip);
    fprintf(stderr,"My name is %s: %s\n", myname.c_str(), this_ip.c_str());
    fprintf(stderr,"Binding Socket to %s:%d \n", this_ip.c_str(), port);
  }else
    myip = this_ip;
  if( sock->bind(myip,port) == -1){
    fprintf(stderr,"Error:bind failed in Listener()\n");
    perror("sock->bind");
    return -1;
  }
  fprintf(stderr,"Listening to sender socket ...");
  if( sock->listen() == -1){
    fprintf(stderr,"Error: failed in Listener()\n");
    return -1;
  }else{
    fprintf(stderr,"Successed\n");
    fprintf(stderr,"DEBUG: Waiting for connection with port(%d)\n", port);
  }

  return 1;

}

const int Get_myport(Socket& s){
  struct sockaddr_in adr;
  socklen_t  len=sizeof(adr);
  if( getsockname(s.get_sockd(),(sockaddr*)&adr,&len) ==0){
    return ntohs(adr.sin_port);
    
  }else{
    perror("Get_myport");
    return -1;
  }
  
}


template <class T>
inline const T Min( const T& a, const T&b)
{ return (a > b ? b : a);}

template <class T>
inline const T Abs( const T& a)
{ return (a > 0 ? a : -a);}

#endif
