/*
 *  Options.h
 *  vrtp
 *
 *  Created by David Lapsley on Mon Feb 23 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef OPTIONS_H
#define OPTIONS_H

#include <common.h>
#include <string>
#include <RTP.h>
#include <Scan.h>
#ifdef XMLPARSING
#include <XMLParser.h>
#endif // XMLPARSING

using namespace std;



struct Options {
	 // Mode selection.
  Mode _mode;
  int _debug_level;

	 // Network.
  int _data_port;
  int _control_port;
  string _src_addr;
  string _dst_addr;
  int _host_mtu;
  int _network_mtu;
	 int _max_window;
  int _max_bucket;
  u_int32_t _ssrc;
  TSpec _t_spec;     // Transmission Specification 
  double _rtcp_interval;

	 // VSI-E
  u_int32_t _frequency;	 
  u_int32_t _packet_size;
  u_int32_t _bits_per_sample;
  u_int32_t _samples_per_packet;

	 // Test.
  double _tvg_duration;

	 // Misc.
  int _protocol;
  int _max_time;
  string _xml_file;
  int _mjd;
  bool _k5udp;

  Options(int argc, char* const argv[]);
  ~Options();

  void usage(ostream& c) const;
  void dump(ostream& c) const;
};


#endif

